/* ISDN Monitor panel applet
 * Insprired by kimon by Markus Dahlweid dahlweid@tzi.org 
 *
 * By Uwe Steinmann <Uwe.Steinmann@fernuni-hagen.de>
 *
 * Enjoy.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or 
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License  
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "phonenumbers.h"

GList *phonelist = NULL;

static void
my_list_print(gpointer list_data, gpointer user_data) {
	CALLER *caller;

	caller = (CALLER *) list_data;
	g_print("%s - %s\n", caller->number, caller->name);
}

CALLER *
add_phonenumber(char *number, char *name) {
	CALLER *caller;
	caller = malloc(sizeof(CALLER));
	caller->number = strdup(number);
	caller->name = strdup(name);
	phonelist = g_list_append (g_list_last(phonelist), caller);
	g_print("%d\n", g_list_length(g_list_first(phonelist)));
	g_list_foreach(g_list_first(phonelist), my_list_print, NULL);
	return(caller);
}

int
read_phonenumbers(char *phonefile) {
	char buffer[BUFFERSIZE];
	char *ptr, *ptr2;
	FILE *fp;
	CALLER *caller;

	if(phonelist) {
		phonelist = g_list_first(phonelist);
		g_list_free(phonelist);
		phonelist = NULL;
	}

	if(NULL == (fp = fopen(phonefile, "r"))) {
		return -1;
	}

	while(!feof(fp)) {
		fgets(buffer, BUFFERSIZE, fp);
		ptr = buffer;
		while(*ptr != '\0' && *ptr != ' ')
			ptr++;
		if(*ptr == ' ') {
			caller = malloc(sizeof(CALLER));
			*ptr = '\0';
			caller->number = strdup(buffer);
			ptr++;
			ptr2 = ptr;
			while(*ptr2 != '\0' && *ptr2 != '\n')
				ptr2++;
			*ptr2 = '\0';
			caller->name = strdup(ptr);
			phonelist = g_list_append (phonelist, caller);
		}
	}
	/*
	g_print("%d\n", g_list_length(g_list_first(phonelist)));
	g_list_foreach(g_list_first(phonelist), my_list_print, NULL);
	*/

	return 0;
}

int
save_phonenumbers(char *filename) {
	GList *list;
	FILE *fp;

	if(phonelist == NULL)
		return NULL;
	list = g_list_first(phonelist);
	if(NULL == (fp = fopen(filename, "w"))) {
		return -1;
	}
	while(list) {
		fprintf(fp, "%s %s\n", ((CALLER *) list->data)->number, ((CALLER *) list->data)->name);
		list = list->next;
	}
	fclose(fp);
	return(NULL);
}

char *
get_phonename(char *number) {
	GList *list;

	if(phonelist == NULL)
		return NULL;
	list = g_list_first(phonelist);
	while(list) {
		if(!strcmp(((CALLER *) list->data)->number, number))
			return(((CALLER *) list->data)->name);
		list = list->next;
	}
	return(NULL);
}
